"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lavalink_1 = require("lavalink");
const Redis = require("ioredis");
const QueueStore_1 = require("./QueueStore");
class LavaqueueNode extends lavalink_1.default {
    constructor(opts) {
        if (!opts.hosts || !opts.hosts.redis)
            throw new Error('cannot make a queue without a Redis connection');
        super(opts);
        this.queues = new QueueStore_1.default(this, opts.hosts.redis instanceof Redis ? opts.hosts.redis : new Redis(opts.hosts.redis));
        this.advanceBy = opts.advanceBy || (() => 1);
        for (const name of ['event', 'playerUpdate']) {
            this.on(name, (d) => {
                this.queues.get(d.guildId).emit(name, d);
            });
        }
    }
}
exports.default = LavaqueueNode;

//# sourceMappingURL=Node.js.map
