import Node, { ConnectionOptions, NodeOptions } from 'lavalink';
import Redis = require('ioredis');
import Queue from './Queue';
import QueueStore from './QueueStore';
export interface Options extends NodeOptions {
    hosts?: {
        ws?: string | {
            url: string;
            options: ConnectionOptions;
        };
        rest?: string;
        redis?: Redis.Redis | Redis.RedisOptions;
    };
    advanceBy?: (queue: Queue, info: {
        previous: string;
        remaining: number;
    }) => number;
}
export default class LavaqueueNode extends Node {
    readonly queues: QueueStore;
    advanceBy: (queue: Queue, info: {
        previous: string;
        remaining: number;
    }) => number;
    constructor(opts: Options);
}
